#ifndef REGLE_H
#define REGLE_H

#include "PtrPartage.h"
#include "Etat.h"
#include "Predicat.h"
#include "Transition.h"

class Regle
{
   PtrPartage<Predicat> pred_;
   PtrPartage<Transition> prochain_;
public:
   Regle(PtrPartage<Predicat> pred, PtrPartage<Transition> prochain = PtrPartage<Transition>())
      : pred_(pred), prochain_(prochain)
   {
   }
   bool operator()(PtrPartage<Etat> e) const
      { return pred_->verifier(e); }
   PtrPartage<Transition>& prochain()
      { return prochain_; }
   const PtrPartage<Transition>& prochain() const
      { return prochain_; }
};

#endif
